"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElasticsearchLoggerService = void 0;
const elasticsearch_1 = require("@elastic/elasticsearch");
const common_1 = require("@nestjs/common");
const ElasticsearchLoggerOptions_1 = require("./ElasticsearchLoggerOptions");
const os = require("os");
let ElasticsearchLoggerService = class ElasticsearchLoggerService {
    constructor(options) {
        this.options = options;
        this.client = new elasticsearch_1.Client(options.elasticsearchClientOptions);
    }
    async createIndex(index) {
        console.log(index);
        const result = await this.client.indices.exists({ index });
        console.log(result);
        if (result.statusCode !== 200) {
            console.log(await this.client.indices.create({
                index,
                body: {
                    mappings: {
                        log: {
                            properties: {
                                date: {
                                    type: 'date'
                                },
                                hostname: {
                                    type: 'text',
                                    fields: {
                                        keyword: {
                                            type: 'keyword'
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }));
        }
    }
    log(level, message, indice) {
        this.createIndex(indice);
        return;
        this.client.index({
            index: indice ? indice : this.options.index,
            body: {
                date: new Date(),
                hostname: os.hostname(),
                level,
                body: message
            }
        });
        if (this.options.stdout) {
            console.log(`[${this.options.name}] ${JSON.stringify(message)}`);
        }
    }
    raw(message, indice) {
        this.client.index({
            index: indice ? indice : this.options.index,
            body: message
        });
        if (this.options.stdout) {
            console.log(`[${this.options.name}] ${JSON.stringify(message)}`);
        }
    }
    info(message, indice) {
        this.log('info', message, indice);
    }
    error(message, indice) {
        this.log('error', message, indice);
    }
    debug(message, indice) {
        this.log('debug', message, indice);
    }
    warning(message, indice) {
        this.log('warning', message, indice);
    }
    trace(message, indice) {
        this.log('trace', message, indice);
    }
    search(obj) {
        return this.client.search(obj);
    }
};
ElasticsearchLoggerService = __decorate([
    __param(0, common_1.Inject('CONFIG_OPTIONS')),
    __metadata("design:paramtypes", [ElasticsearchLoggerOptions_1.ElasticsearchLoggerOptions])
], ElasticsearchLoggerService);
exports.ElasticsearchLoggerService = ElasticsearchLoggerService;
//# sourceMappingURL=ElasticsearchLoggerService.js.map